/* @pjs pauseOnBlur=true; */
//=============================================================================
//  ©J.Roussel -- 3 dec. 2013
//========== IDEES ==================

int R=70;//rayon du du cercle
int omega=2;// vitesse angulaire (en degré/frame)
int time,periode;
float posX, posY;//coordonnées du pointM
boolean playing = true;

void setup() {
  size(500, 250);
  frameRate(20);
  smooth();
  time=0;
  periode=360/omega;
  text("", 0, 0);  // force Processing to load a font
  background(255);
  trace_axes();
  
    
}

void draw() {
  if(time<=int(360/omega)){
  trace_trajectoire();
  time+=1;
  }
  else{
    pause(); trace_axes();time=0;}  
}

void trace_trajectoire(){
  pushMatrix();
  fill(255);
  noStroke();
  rect(0,0,width/2-20,height);
  translate(width/4, height/2);
  stroke(100);fill(0);
  line(-10,0,R+10,0);
  text("x",R+5,-5);
  line(0,10,0,-R-10);
  text("y",5,-R-5);
  ellipseMode(CENTER);
  noFill();
  ellipse(0, 0, 2*R, 2*R);
  posX=R*cos(radians(omega*time));
  posY=-R*sin(radians(omega*time));
  line(0,0,posX,posY);
  noStroke();
  fill(150, 0, 0,200);
  ellipse(posX, posY, 15, 15);
//tracé des axes
  translate(width/4,0);
//tracé de x(t) et y(t)
  translate(time,0);
  fill(150,0,0,100);
  ellipse(0,-posX,3,3); 
  fill(0,0,150,100);
  ellipse(0,posY,3,3); 
  popMatrix();
}

void trace_axes(){
  noStroke();fill(255);textSize(12);
  rect(width/2,0,width,height);
  pushMatrix();
  fill(0);
  stroke(0);
   translate(width/2, height/2);
  line(-20,0,periode+20,0);
  text("temps",periode+30,0);
  beginShape(TRIANGLES);
  vertex(periode+20,-5);
  vertex(periode+25, 0);
  vertex(periode+20, 5);
  endShape();
  line(0,-R-20,0,R+20);
  beginShape(TRIANGLES);
  vertex(5,-R-20);
  vertex(0,-R-25);
  vertex(-5,-R-20);
  endShape();
  stroke(150,0,0);
  line(R,-R-20,R+20,-R-20);
  text("x(t)",R+30,-R-20);
  stroke(0,0,150);
  line(R+100,-R-20,R+120,-R-20);
  text("y(t)",R+130,-R-20);
  popMatrix();
}


/*** Start playback */
void play() {
  playing = true;
  loop();
} 
/*** Pause playback */
void pause() {
  playing = false;
//  fill(127, 127, 127, 127);
  noFill();noStroke();
  rect(0, 0, width, height);
  fill(100);
  String pausetext = " click to play/pause";
  textSize(20);
  float twidth = textWidth(pausetext);
  text(pausetext, (width/2-twidth)/2, 20);
  textSize(10);
  noLoop();
}


void mouseClicked() {
  if (!playing) { 
    play();
  }
  else { 
    pause();
  }
}


